/*===========================================================================

ObjectWeb Util Launcher package.
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): Jerome Moroy.

===========================================================================*/

package org.objectweb.util.launcher;

/**
 * Parses a Java object wihch representes an XML Configuration.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 * @version 0.1
 */
public interface ConfigDecoder
{
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Parses the properties file.
     *
     * @param file The property file containing the configuration.
     *
     * @return The status (true if ok, else false).
     */
    public boolean parse(String file);

    /**
     * Get the class to launch.
     *
     * @return The class name.
     */
    public String getClassName();

    /**
     * Get the jar list associated to the CONFIGURATION.
     *
     * @return An array of jars.
     */
    public String[] getJarList();

    /**
     * Get the static option list associated to the CONFIGURATION.
     *
     * @return An array of static options.
     */
    public String[] getStaticoptionList();
}
