package org.objectweb.zeusx;

import java.util.List;

import org.enhydra.zeus.binding.Property;
import org.enhydra.zeus.util.CapitalizationUtils;
import org.enhydra.zeus.util.ClassUtils;


public class ModelBindings extends java.util.Hashtable
{
    private java.util.Hashtable default_gui_table;

    // the constructor : it uses the package as a reference to find the model file in the modelsDirectory
    public ModelBindings (String packageName,
                                String modelsDirectory)
    {
        // a default model, built on the XML attributes defaults given in the DTD
        org.objectweb.zeusx.descriptor.zeusx.Guimodel default_gui_model = new org.objectweb.zeusx.descriptor.zeusx.GuimodelImpl();
        org.objectweb.zeusx.descriptor.zeusx.Mapelement default_mapped_element = new org.objectweb.zeusx.descriptor.zeusx.MapelementImpl();
        default_gui_table = new java.util.Hashtable();
        default_gui_table.put("javaclass"
                        ,default_gui_model.getJavaclass());
        default_gui_table.put("retrievemethod"
                        ,default_gui_model.getRetrievemethod());
        default_gui_table.put("feedmethod"
                        ,default_gui_model.getFeedmethod());
        default_gui_table.put("display"
                        ,default_gui_model.getInparent());
        default_gui_table.put("inparent"
                        ,default_gui_model.getInparent());
        default_gui_table.put("displaylabel"
                        ,default_gui_model.getDisplaylabel());
	try
        {
            // looking for a file containing extended infos
	    java.io.File extensions_file = new java.io.File(modelsDirectory
				+packageName.substring(packageName.lastIndexOf(".")+1)
				+".zeusx");

	    if ( extensions_file.exists() )
            {
                org.objectweb.zeusx.descriptor.zeusx.Zeusx extensions
                        = org.objectweb.zeusx.descriptor.zeusx.ZeusxUnmarshaller.unmarshal (extensions_file);

		// getting mapped elements in the exensions file
                java.util.List extended_elements = extensions.getMapelementList();

                for (java.util.Iterator elements_iterator = extended_elements.iterator(); elements_iterator.hasNext(); )
                {
                    org.objectweb.zeusx.descriptor.zeusx.Mapelement extended_element
                        = (org.objectweb.zeusx.descriptor.zeusx.Mapelement) elements_iterator.next();

                    java.util.Hashtable gui_table = new java.util.Hashtable();

		    // getting the guimodels list to prepare the element mapping
                    java.util.List gui_models = extensions.getGuimodelList();

		    // checking the info extension, that generates classes used during deployment process
                    if (extended_element.getInfo()!= null)
		    {
		        if (extended_element.getInfo().getType()!= null)
                            gui_table.put("#_info_type",extended_element.getInfo().getType());
			if (extended_element.getInfo().getRef()!= null)
			    gui_table.put("#_info_ref",extended_element.getInfo().getRef());
		    }

                    for (java.util.Iterator models_iterator = gui_models.iterator(); models_iterator.hasNext(); )
                    {
                        org.objectweb.zeusx.descriptor.zeusx.Guimodel guimodel
                            = (org.objectweb.zeusx.descriptor.zeusx.Guimodel) models_iterator.next();

			// comparing each defined guimodel to the mapped element's wanted guimodel
                        if ( guimodel.getId().equals(extended_element.getGuimodel()) )
                        {
                            gui_table.put("#_display"
                                        ,guimodel.getInparent());
                            gui_table.put("#_inparent"
                                        ,guimodel.getInparent());
                            gui_table.put("#_displaylabel"
                                        ,guimodel.getDisplaylabel());
                        }
                    }

		    // getting the mapped attributes of this mapped element
                    java.util.List mapped_attributes = extended_element.getMapattributeList();
                    for (java.util.Iterator attributes_iterator = mapped_attributes.iterator(); attributes_iterator.hasNext(); )
                    {
                        org.objectweb.zeusx.descriptor.zeusx.Mapattribute extended_attribute
                            = (org.objectweb.zeusx.descriptor.zeusx.Mapattribute) attributes_iterator.next();

                        for (java.util.Iterator models_iterator = gui_models.iterator(); models_iterator.hasNext(); )
                        {
                            org.objectweb.zeusx.descriptor.zeusx.Guimodel guimodel
                                = (org.objectweb.zeusx.descriptor.zeusx.Guimodel) models_iterator.next();

			    // comparing each defined guimodel to the mapped attribute's wanted guimodel
                            if ( guimodel.getId().equals(extended_attribute.getGuimodel()) )
                            {
                                gui_table.put(extended_attribute.getName()+"_javaclass"
                                                ,guimodel.getJavaclass());
                                gui_table.put(extended_attribute.getName()+"_retrievemethod"
                                                ,guimodel.getRetrievemethod());
                                gui_table.put(extended_attribute.getName()+"_feedmethod"
                                                ,guimodel.getFeedmethod());
                            }
                        }
                    }
		    // feeding the main hashtable with the filled gui_table
                    this.put(extended_element.getName(),gui_table);
                }
            }
    	} catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String getMappingFor(String element, String attribute, String whatYouNeed)
    {
    // this method is called by the generators when they meet elements and attributes for which they want the mapping

        if (whatYouNeed.equals(null)
                || attribute.equals(null)
                || element.equals(null))
        {
            return null;
        }
        if (!this.containsKey(element))
        {
            return ( (String) (this.default_gui_table.get(whatYouNeed)) );
        }
        java.util.Hashtable mappedElement = (java.util.Hashtable) this.get(element);
        if (!mappedElement.containsKey(attribute+"_"+whatYouNeed))
        {
            return ( (String) (this.default_gui_table.get(whatYouNeed)) );
        }
        return ( (String) (mappedElement.get(attribute+"_"+whatYouNeed)) );
    }
}

